#property copyright "Copyright 2013 expforex"
#property link      "http://www.expforex.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
//---- indicator parameters
extern int MA_Period=13;
extern int MA_Shift=0;
extern int MA_Method=0;
extern int BAR=30;
//---- indicator buffers
double ExtMapBuffer[];
double ExtMapBuffer2[];
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
   string short_name;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexShift(0,MA_Shift);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexShift(1,MA_Shift);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(MA_Period<2) MA_Period=13;
   draw_begin=MA_Period-1;
//---- indicator short name
   switch(MA_Method)
     {
      case 1 : short_name="www.expforex.com EMA(";  draw_begin=0; break;
      case 2 : short_name="www.expforex.com SMMA("; break;
      case 3 : short_name="www.expforex.com LWMA("; break;
      default :
         MA_Method=0;
         short_name="www.expforex.com SMA(";
     }
   IndicatorShortName(short_name+MA_Period+")");
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,ExtMapBuffer2);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {

   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
//----
();



//---- done
   return(0);
  }
  
void ()
  {
   double sum=0;
   int    i,pos=Bars-ExtCountedBars-1;
//---- initial accumulation 

   double clos=Close[BAR];
   
   SetVLine(Blue,"BAR",Time[BAR]);
   for(i=BAR;i<pos;i++)
   {ExtMapBuffer[i]=clos+(clos-Close[i]);}
   
   for(i=BAR;i>0;i--)
   {ExtMapBuffer[i]=iMA(Symbol(),0,MA_Period,MA_Shift,MA_Method,PRICE_CLOSE,i);}
  
   for(i=0;i<pos;i++)
   {ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer,0,MA_Period,MA_Shift,MA_Method,i);}
  
  }
  
void SetVLine(color cl, string nm="", datetime t1=0, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[0];
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_VLINE, 0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1, t1);
  ObjectSet(nm, OBJPROP_COLOR, cl);
  ObjectSet(nm, OBJPROP_STYLE, st);
  ObjectSet(nm, OBJPROP_WIDTH, wd);
}
    